#include "mbed.h"

int main() {
    //enable clock for PORTC
    SIM->SCGC5 |= (1UL << 11);
    //set PORTC pin 5 as pulse counter pin (PIN ALT3: LPTMR0_ALT2)
    PORTC->PCR[5] = (1UL << 9) | (1UL << 8);

    //enable clock for LPTMR0
    SIM->SCGC5 |= (1UL << 0);
    // reset LPTMR
    LPTMR0->CSR = 0;
    LPTMR0->PSR = 0;
    LPTMR0->CMR = 0; // no need for compare value because i will use counter in free running mode

    //select LPTMR0_ALT2 (PTC5) as pulse counter pin
    LPTMR0->CSR |= (1 << 5);
    //counter is free running
    LPTMR0->CSR |= (1 << 2);
    //select pulse counter mode
    LPTMR0->CSR |= (1 << 1);

    //pulse counter input pin directly clocks counter value (bypass glitch filter)
    LPTMR0->PSR = (1 << 2);

    //enable LPTMR module
    LPTMR0->CSR |= (1 << 0);

    while (true) {
         LPTMR0->CNR = 1; // write any value first to CNR to read CNR value
         printf("counter value: %lu\r\n", LPTMR0->CNR);

         wait(1.0f);
    }
}